# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/sql/property/integer'
require 'google/sql/property/string'
require 'google/sql/property/string_array'
require 'puppet'

Puppet::Type.newtype(:gsql_tier) do
  @doc = <<-DOC
    The Tiers resource represents a service configuration that can be used to
    define a Cloud SQL instance. Each tier has an associated RAM, maximum
    storage, and list of regions in which the tier can be used. Available tiers
    vary depending on whether you use PostgreSQL, MySQL Second Generation, or
    MySQL First Generation instances.
  DOC

  autorequire(:gauth_credential) do
    credential = self[:credential]
    raise "#{ref}: required property 'credential' is missing" if credential.nil?
    [credential]
  end

  newparam :credential do
    desc <<-DESC
      A gauth_credential name to be used to authenticate with Google Cloud
      Platform.
    DESC
  end

  newparam(:project) do
    desc 'A Google Cloud Platform project to manage.'
  end

  newparam(:tier, namevar: true, parent: Google::Sql::Property::String) do
    desc <<-DOC
      An identifier for the service tier or machine type, for example,
      db-n1-standard-1. For related information.
    DOC
  end

  newproperty(:disk_quota, parent: Google::Sql::Property::Integer) do
    desc 'The maximum disk size of this tier in bytes. (output only)'
  end

  newproperty(:ram, parent: Google::Sql::Property::Integer) do
    desc 'The maximum RAM usage of this tier in bytes. (output only)'
  end

  newproperty(:region, parent: Google::Sql::Property::StringArray) do
    desc 'The applicable regions for this tier. (output only)'
  end
end
