# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'spec_helper'

describe Puppet::Type.type(:gsql_instance).provider(:google) do
  before(:all) do
    cred = Google::FakeAuthorization.new
    Puppet::Type.type(:gauth_credential)
                .define_singleton_method(:fetch) { |_resource| cred }
  end

  it '#instances' do
    expect { described_class.instances }.to raise_error(StandardError,
                                                        /not supported/)
  end

  context 'ensure == present' do
    context 'resource exists' do
      # Ensure present: resource exists, no change
      context 'no changes == no action' do
        # Ensure present: resource exists, no change, no name
        context 'title == name' do
          # Ensure present: resource exists, no change, no name, pass
          context 'title == name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1, name: 'title0'
              expect_network_get_success 2, name: 'title1'
              expect_network_get_success 3, name: 'title2'
            end

            let(:catalog) do
              apply_with_error_check(
                <<-MANIFEST
                gsql_instance { 'title0':
                  ensure                => present,
                  backend_type          => 'FIRST_GEN',
                  connection_name       => 'test connection_name#0 data',
                  database_version      => 'MYSQL_5_5',
                  failover_replica      => {
                    available => true,
                    name      => 'test name#0 data',
                  },
                  instance_type         => 'CLOUD_SQL_INSTANCE',
                  ipv6_address          => 'test ipv6_address#0 data',
                  master_instance_name  => 'test master_instance_name#0 data',
                  max_disk_size         => 399168897,
                  region                => 'test region#0 data',
                  replica_configuration => {
                    failover_target               => true,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#0 data',
                      client_certificate        => 'test client_certificate#0 data',
                      client_key                => 'test client_key#0 data',
                      connect_retry_interval    => 586223489,
                      dump_file_path            => 'test dump_file_path#0 data',
                      master_heartbeat_period   => 2641537687,
                      password                  => 'test password#0 data',
                      ssl_cipher                => 'test ssl_cipher#0 data',
                      username                  => 'test username#0 data',
                      verify_server_certificate => true,
                    },
                    replica_names                 => ['ee', 'ff', 'gg', 'hh'],
                    service_account_email_address => 'test service_account_email_address#0 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2018-07-08T02:10:16+00:00',
                          name            => 'test name#0 data',
                          value           => 'test value#0 data',
                        },
                        {
                          expiration_time => '2067-01-12T04:20:32+00:00',
                          name            => 'test name#1 data',
                          value           => 'test value#1 data',
                        },
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                      ],
                      ipv4_enabled        => true,
                      require_ssl         => true,
                    },
                    tier             => 'test tier#0 data',
                  },
                  project               => 'test project#0 data',
                  credential            => 'cred0',
                }

                gsql_instance { 'title1':
                  ensure                => present,
                  backend_type          => 'SECOND_GEN',
                  connection_name       => 'test connection_name#1 data',
                  database_version      => 'MYSQL_5_6',
                  failover_replica      => {
                    available => false,
                    name      => 'test name#1 data',
                  },
                  instance_type         => 'ON_PREMISES_INSTANCE',
                  ipv6_address          => 'test ipv6_address#1 data',
                  master_instance_name  => 'test master_instance_name#1 data',
                  max_disk_size         => 798337795,
                  region                => 'test region#1 data',
                  replica_configuration => {
                    failover_target               => false,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#1 data',
                      client_certificate        => 'test client_certificate#1 data',
                      client_key                => 'test client_key#1 data',
                      connect_retry_interval    => 1172446978,
                      dump_file_path            => 'test dump_file_path#1 data',
                      master_heartbeat_period   => 5283075375,
                      password                  => 'test password#1 data',
                      ssl_cipher                => 'test ssl_cipher#1 data',
                      username                  => 'test username#1 data',
                      verify_server_certificate => false,
                    },
                    replica_names                 => ['kk', 'll'],
                    service_account_email_address => 'test service_account_email_address#1 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2067-01-12T04:20:32+00:00',
                          name            => 'test name#1 data',
                          value           => 'test value#1 data',
                        },
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                        {
                          expiration_time => '2164-01-24T08:41:04+00:00',
                          name            => 'test name#3 data',
                          value           => 'test value#3 data',
                        },
                        {
                          expiration_time => '2212-07-31T10:51:20+00:00',
                          name            => 'test name#4 data',
                          value           => 'test value#4 data',
                        },
                        {
                          expiration_time => '2261-02-04T13:01:36+00:00',
                          name            => 'test name#5 data',
                          value           => 'test value#5 data',
                        },
                      ],
                      ipv4_enabled        => false,
                      require_ssl         => false,
                    },
                    tier             => 'test tier#1 data',
                  },
                  project               => 'test project#1 data',
                  credential            => 'cred1',
                }

                gsql_instance { 'title2':
                  ensure                => present,
                  backend_type          => 'EXTERNAL',
                  connection_name       => 'test connection_name#2 data',
                  database_version      => 'MYSQL_5_7',
                  failover_replica      => {
                    available => true,
                    name      => 'test name#2 data',
                  },
                  instance_type         => 'READ_REPLICA_INSTANCE',
                  ipv6_address          => 'test ipv6_address#2 data',
                  master_instance_name  => 'test master_instance_name#2 data',
                  max_disk_size         => 1197506692,
                  region                => 'test region#2 data',
                  replica_configuration => {
                    failover_target               => true,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#2 data',
                      client_certificate        => 'test client_certificate#2 data',
                      client_key                => 'test client_key#2 data',
                      connect_retry_interval    => 1758670468,
                      dump_file_path            => 'test dump_file_path#2 data',
                      master_heartbeat_period   => 7924613063,
                      password                  => 'test password#2 data',
                      ssl_cipher                => 'test ssl_cipher#2 data',
                      username                  => 'test username#2 data',
                      verify_server_certificate => true,
                    },
                    replica_names                 => ['qq', 'rr', 'ss', 'tt'],
                    service_account_email_address => 'test service_account_email_address#2 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                        {
                          expiration_time => '2164-01-24T08:41:04+00:00',
                          name            => 'test name#3 data',
                          value           => 'test value#3 data',
                        },
                      ],
                      ipv4_enabled        => true,
                      require_ssl         => true,
                    },
                    tier             => 'test tier#2 data',
                  },
                  project               => 'test project#2 data',
                  credential            => 'cred2',
                }
                MANIFEST
              ).catalog
            end

            context 'Gsql_instance[title0]' do
              subject do
                catalog.resource('Gsql_instance[title0]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'FIRST_GEN') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#0 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_5')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'CLOUD_SQL_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#0 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#0 data'
                  )
              end
              it { is_expected.to have_attributes(max_disk_size: 399_168_897) }
              it { is_expected.to have_attributes(name: 'title0') }
              it do
                is_expected.to have_attributes(region: 'test region#0 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end

            context 'Gsql_instance[title1]' do
              subject do
                catalog.resource('Gsql_instance[title1]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'SECOND_GEN') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#1 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_6')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'ON_PREMISES_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#1 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#1 data'
                  )
              end
              it { is_expected.to have_attributes(max_disk_size: 798_337_795) }
              it { is_expected.to have_attributes(name: 'title1') }
              it do
                is_expected.to have_attributes(region: 'test region#1 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end

            context 'Gsql_instance[title2]' do
              subject do
                catalog.resource('Gsql_instance[title2]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'EXTERNAL') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#2 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_7')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'READ_REPLICA_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#2 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#2 data'
                  )
              end
              it do
                is_expected.to have_attributes(max_disk_size: 1_197_506_692)
              end
              it { is_expected.to have_attributes(name: 'title2') }
              it do
                is_expected.to have_attributes(region: 'test region#2 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end
          end

          # Ensure present: resource exists, no change, no name, fail
          context 'title == name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, no change, has name
        context 'title != name' do
          # Ensure present: resource exists, no change, has name, pass
          context 'title != name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1
              expect_network_get_success 2
              expect_network_get_success 3
            end

            let(:catalog) do
              apply_with_error_check(
                <<-MANIFEST
                gsql_instance { 'title0':
                  ensure                => present,
                  backend_type          => 'FIRST_GEN',
                  connection_name       => 'test connection_name#0 data',
                  database_version      => 'MYSQL_5_5',
                  failover_replica      => {
                    available => true,
                    name      => 'test name#0 data',
                  },
                  instance_type         => 'CLOUD_SQL_INSTANCE',
                  ipv6_address          => 'test ipv6_address#0 data',
                  master_instance_name  => 'test master_instance_name#0 data',
                  max_disk_size         => 399168897,
                  name                  => 'test name#0 data',
                  region                => 'test region#0 data',
                  replica_configuration => {
                    failover_target               => true,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#0 data',
                      client_certificate        => 'test client_certificate#0 data',
                      client_key                => 'test client_key#0 data',
                      connect_retry_interval    => 586223489,
                      dump_file_path            => 'test dump_file_path#0 data',
                      master_heartbeat_period   => 2641537687,
                      password                  => 'test password#0 data',
                      ssl_cipher                => 'test ssl_cipher#0 data',
                      username                  => 'test username#0 data',
                      verify_server_certificate => true,
                    },
                    replica_names                 => ['ee', 'ff', 'gg', 'hh'],
                    service_account_email_address => 'test service_account_email_address#0 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2018-07-08T02:10:16+00:00',
                          name            => 'test name#0 data',
                          value           => 'test value#0 data',
                        },
                        {
                          expiration_time => '2067-01-12T04:20:32+00:00',
                          name            => 'test name#1 data',
                          value           => 'test value#1 data',
                        },
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                      ],
                      ipv4_enabled        => true,
                      require_ssl         => true,
                    },
                    tier             => 'test tier#0 data',
                  },
                  project               => 'test project#0 data',
                  credential            => 'cred0',
                }

                gsql_instance { 'title1':
                  ensure                => present,
                  backend_type          => 'SECOND_GEN',
                  connection_name       => 'test connection_name#1 data',
                  database_version      => 'MYSQL_5_6',
                  failover_replica      => {
                    available => false,
                    name      => 'test name#1 data',
                  },
                  instance_type         => 'ON_PREMISES_INSTANCE',
                  ipv6_address          => 'test ipv6_address#1 data',
                  master_instance_name  => 'test master_instance_name#1 data',
                  max_disk_size         => 798337795,
                  name                  => 'test name#1 data',
                  region                => 'test region#1 data',
                  replica_configuration => {
                    failover_target               => false,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#1 data',
                      client_certificate        => 'test client_certificate#1 data',
                      client_key                => 'test client_key#1 data',
                      connect_retry_interval    => 1172446978,
                      dump_file_path            => 'test dump_file_path#1 data',
                      master_heartbeat_period   => 5283075375,
                      password                  => 'test password#1 data',
                      ssl_cipher                => 'test ssl_cipher#1 data',
                      username                  => 'test username#1 data',
                      verify_server_certificate => false,
                    },
                    replica_names                 => ['kk', 'll'],
                    service_account_email_address => 'test service_account_email_address#1 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2067-01-12T04:20:32+00:00',
                          name            => 'test name#1 data',
                          value           => 'test value#1 data',
                        },
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                        {
                          expiration_time => '2164-01-24T08:41:04+00:00',
                          name            => 'test name#3 data',
                          value           => 'test value#3 data',
                        },
                        {
                          expiration_time => '2212-07-31T10:51:20+00:00',
                          name            => 'test name#4 data',
                          value           => 'test value#4 data',
                        },
                        {
                          expiration_time => '2261-02-04T13:01:36+00:00',
                          name            => 'test name#5 data',
                          value           => 'test value#5 data',
                        },
                      ],
                      ipv4_enabled        => false,
                      require_ssl         => false,
                    },
                    tier             => 'test tier#1 data',
                  },
                  project               => 'test project#1 data',
                  credential            => 'cred1',
                }

                gsql_instance { 'title2':
                  ensure                => present,
                  backend_type          => 'EXTERNAL',
                  connection_name       => 'test connection_name#2 data',
                  database_version      => 'MYSQL_5_7',
                  failover_replica      => {
                    available => true,
                    name      => 'test name#2 data',
                  },
                  instance_type         => 'READ_REPLICA_INSTANCE',
                  ipv6_address          => 'test ipv6_address#2 data',
                  master_instance_name  => 'test master_instance_name#2 data',
                  max_disk_size         => 1197506692,
                  name                  => 'test name#2 data',
                  region                => 'test region#2 data',
                  replica_configuration => {
                    failover_target               => true,
                    mysql_replica_configuration   => {
                      ca_certificate            => 'test ca_certificate#2 data',
                      client_certificate        => 'test client_certificate#2 data',
                      client_key                => 'test client_key#2 data',
                      connect_retry_interval    => 1758670468,
                      dump_file_path            => 'test dump_file_path#2 data',
                      master_heartbeat_period   => 7924613063,
                      password                  => 'test password#2 data',
                      ssl_cipher                => 'test ssl_cipher#2 data',
                      username                  => 'test username#2 data',
                      verify_server_certificate => true,
                    },
                    replica_names                 => ['qq', 'rr', 'ss', 'tt'],
                    service_account_email_address => 'test service_account_email_address#2 data',
                  },
                  settings              => {
                    ip_configuration => {
                      authorized_networks => [
                        {
                          expiration_time => '2115-07-20T06:30:48+00:00',
                          name            => 'test name#2 data',
                          value           => 'test value#2 data',
                        },
                        {
                          expiration_time => '2164-01-24T08:41:04+00:00',
                          name            => 'test name#3 data',
                          value           => 'test value#3 data',
                        },
                      ],
                      ipv4_enabled        => true,
                      require_ssl         => true,
                    },
                    tier             => 'test tier#2 data',
                  },
                  project               => 'test project#2 data',
                  credential            => 'cred2',
                }
                MANIFEST
              ).catalog
            end

            context 'Gsql_instance[title0]' do
              subject do
                catalog.resource('Gsql_instance[title0]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'FIRST_GEN') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#0 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_5')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'CLOUD_SQL_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#0 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#0 data'
                  )
              end
              it { is_expected.to have_attributes(max_disk_size: 399_168_897) }
              it { is_expected.to have_attributes(name: 'test name#0 data') }
              it do
                is_expected.to have_attributes(region: 'test region#0 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end

            context 'Gsql_instance[title1]' do
              subject do
                catalog.resource('Gsql_instance[title1]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'SECOND_GEN') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#1 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_6')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'ON_PREMISES_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#1 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#1 data'
                  )
              end
              it { is_expected.to have_attributes(max_disk_size: 798_337_795) }
              it { is_expected.to have_attributes(name: 'test name#1 data') }
              it do
                is_expected.to have_attributes(region: 'test region#1 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end

            context 'Gsql_instance[title2]' do
              subject do
                catalog.resource('Gsql_instance[title2]').provider
              end

              it { is_expected.to have_attributes(backend_type: 'EXTERNAL') }
              it do
                is_expected
                  .to have_attributes(
                    connection_name: 'test connection_name#2 data'
                  )
              end
              it do
                is_expected.to have_attributes(database_version: 'MYSQL_5_7')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'failoverReplica' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(instance_type: 'READ_REPLICA_INSTANCE')
              end
              # TODO(nelsonjr): Implement complex array object test.
              # it 'ipAddresses' do
              #   # Add test code here
              # end
              it do
                is_expected
                  .to have_attributes(ipv6_address: 'test ipv6_address#2 data')
              end
              it do
                is_expected
                  .to have_attributes(
                    master_instance_name: 'test master_instance_name#2 data'
                  )
              end
              it do
                is_expected.to have_attributes(max_disk_size: 1_197_506_692)
              end
              it { is_expected.to have_attributes(name: 'test name#2 data') }
              it do
                is_expected.to have_attributes(region: 'test region#2 data')
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'replicaConfiguration' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'settings' do
              #   # Add test code here
              # end
            end
          end

          # Ensure present: resource exists, no change, has name, fail
          context 'title != name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end

      # Ensure present: resource exists, changes
      context 'changes == action' do
        # Ensure present: resource exists, changes, no name
        context 'title == name' do
          # Ensure present: resource exists, changes, no name, pass
          context 'title == name (pass)' do
            # TODO(nelsonjr): Implement new test format.
          end

          # Ensure present: resource exists, changes, no name, fail
          context 'title == name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, changes, has name
        context 'title != name' do
          # Ensure present: resource exists, changes, has name, pass
          context 'title != name (pass)' do
            # TODO(nelsonjr): Implement new test format.
          end

          # Ensure present: resource exists, changes, has name, fail
          context 'title != name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end
    end

    context 'resource missing' do
      # Ensure present: resource missing, ignore, no name
      context 'title == name' do
        # Ensure present: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            # rubocop:disable Metrics/LineLength
            expect_network_get_failed 1, name: 'title0'
            expect_network_create \
              1,
              {
                'kind' => 'sql#instance',
                'backendType' => 'FIRST_GEN',
                'connectionName' => 'test connection_name#0 data',
                'databaseVersion' => 'MYSQL_5_5',
                'failoverReplica' => {
                  'available' => true,
                  'name' => 'test name#0 data'
                },
                'instanceType' => 'CLOUD_SQL_INSTANCE',
                'ipv6Address' => 'test ipv6_address#0 data',
                'masterInstanceName' => 'test master_instance_name#0 data',
                'maxDiskSize' => 399_168_897,
                'name' => 'title0',
                'region' => 'test region#0 data',
                'replicaConfiguration' => {
                  'failoverTarget' => true,
                  'mysqlReplicaConfiguration' => {
                    'caCertificate' => 'test ca_certificate#0 data',
                    'clientCertificate' => 'test client_certificate#0 data',
                    'clientKey' => 'test client_key#0 data',
                    'connectRetryInterval' => 586_223_489,
                    'dumpFilePath' => 'test dump_file_path#0 data',
                    'masterHeartbeatPeriod' => 2_641_537_687,
                    'password' => 'test password#0 data',
                    'sslCipher' => 'test ssl_cipher#0 data',
                    'username' => 'test username#0 data',
                    'verifyServerCertificate' => true
                  },
                  'replicaNames' => %w[ee ff gg hh],
                  'serviceAccountEmailAddress' => 'test service_account_email_address#0 data'
                },
                'settings' => {
                  'ipConfiguration' => {
                    'ipv4Enabled' => true,
                    'authorizedNetworks' => [
                      {
                        'expirationTime' => '2018-07-08T02:10:16+00:00',
                        'name' => 'test name#0 data',
                        'value' => 'test value#0 data'
                      },
                      {
                        'expirationTime' => '2067-01-12T04:20:32+00:00',
                        'name' => 'test name#1 data',
                        'value' => 'test value#1 data'
                      },
                      {
                        'expirationTime' => '2115-07-20T06:30:48+00:00',
                        'name' => 'test name#2 data',
                        'value' => 'test value#2 data'
                      }
                    ],
                    'requireSsl' => true
                  },
                  'tier' => 'test tier#0 data'
                }
              },
              name: 'title0'
            expect_network_get_async 1, name: 'title0'
            # rubocop:enable Metrics/LineLength
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure                => present,
                backend_type          => 'FIRST_GEN',
                connection_name       => 'test connection_name#0 data',
                database_version      => 'MYSQL_5_5',
                failover_replica      => {
                  available => true,
                  name      => 'test name#0 data',
                },
                instance_type         => 'CLOUD_SQL_INSTANCE',
                ipv6_address          => 'test ipv6_address#0 data',
                master_instance_name  => 'test master_instance_name#0 data',
                max_disk_size         => 399168897,
                region                => 'test region#0 data',
                replica_configuration => {
                  failover_target               => true,
                  mysql_replica_configuration   => {
                    ca_certificate            => 'test ca_certificate#0 data',
                    client_certificate        => 'test client_certificate#0 data',
                    client_key                => 'test client_key#0 data',
                    connect_retry_interval    => 586223489,
                    dump_file_path            => 'test dump_file_path#0 data',
                    master_heartbeat_period   => 2641537687,
                    password                  => 'test password#0 data',
                    ssl_cipher                => 'test ssl_cipher#0 data',
                    username                  => 'test username#0 data',
                    verify_server_certificate => true,
                  },
                  replica_names                 => ['ee', 'ff', 'gg', 'hh'],
                  service_account_email_address => 'test service_account_email_address#0 data',
                },
                settings              => {
                  ip_configuration => {
                    authorized_networks => [
                      {
                        expiration_time => '2018-07-08T02:10:16+00:00',
                        name            => 'test name#0 data',
                        value           => 'test value#0 data',
                      },
                      {
                        expiration_time => '2067-01-12T04:20:32+00:00',
                        name            => 'test name#1 data',
                        value           => 'test value#1 data',
                      },
                      {
                        expiration_time => '2115-07-20T06:30:48+00:00',
                        name            => 'test name#2 data',
                        value           => 'test value#2 data',
                      },
                    ],
                    ipv4_enabled        => true,
                    require_ssl         => true,
                  },
                  tier             => 'test tier#0 data',
                },
                project               => 'test project#0 data',
                credential            => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]').provider.ensure
          end

          it { is_expected.to eq :present }
        end

        # Ensure present: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure present: resource missing, ignore, has name
      context 'title != name' do
        # Ensure present: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            # rubocop:disable Metrics/LineLength
            expect_network_get_failed 1
            expect_network_create \
              1,
              'kind' => 'sql#instance',
              'backendType' => 'FIRST_GEN',
              'connectionName' => 'test connection_name#0 data',
              'databaseVersion' => 'MYSQL_5_5',
              'failoverReplica' => {
                'available' => true,
                'name' => 'test name#0 data'
              },
              'instanceType' => 'CLOUD_SQL_INSTANCE',
              'ipv6Address' => 'test ipv6_address#0 data',
              'masterInstanceName' => 'test master_instance_name#0 data',
              'maxDiskSize' => 399_168_897,
              'name' => 'test name#0 data',
              'region' => 'test region#0 data',
              'replicaConfiguration' => {
                'failoverTarget' => true,
                'mysqlReplicaConfiguration' => {
                  'caCertificate' => 'test ca_certificate#0 data',
                  'clientCertificate' => 'test client_certificate#0 data',
                  'clientKey' => 'test client_key#0 data',
                  'connectRetryInterval' => 586_223_489,
                  'dumpFilePath' => 'test dump_file_path#0 data',
                  'masterHeartbeatPeriod' => 2_641_537_687,
                  'password' => 'test password#0 data',
                  'sslCipher' => 'test ssl_cipher#0 data',
                  'username' => 'test username#0 data',
                  'verifyServerCertificate' => true
                },
                'replicaNames' => %w[ee ff gg hh],
                'serviceAccountEmailAddress' => 'test service_account_email_address#0 data'
              },
              'settings' => {
                'ipConfiguration' => {
                  'ipv4Enabled' => true,
                  'authorizedNetworks' => [
                    {
                      'expirationTime' => '2018-07-08T02:10:16+00:00',
                      'name' => 'test name#0 data',
                      'value' => 'test value#0 data'
                    },
                    {
                      'expirationTime' => '2067-01-12T04:20:32+00:00',
                      'name' => 'test name#1 data',
                      'value' => 'test value#1 data'
                    },
                    {
                      'expirationTime' => '2115-07-20T06:30:48+00:00',
                      'name' => 'test name#2 data',
                      'value' => 'test value#2 data'
                    }
                  ],
                  'requireSsl' => true
                },
                'tier' => 'test tier#0 data'
              }
            expect_network_get_async 1
            # rubocop:enable Metrics/LineLength
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure                => present,
                backend_type          => 'FIRST_GEN',
                connection_name       => 'test connection_name#0 data',
                database_version      => 'MYSQL_5_5',
                failover_replica      => {
                  available => true,
                  name      => 'test name#0 data',
                },
                instance_type         => 'CLOUD_SQL_INSTANCE',
                ipv6_address          => 'test ipv6_address#0 data',
                master_instance_name  => 'test master_instance_name#0 data',
                max_disk_size         => 399168897,
                name                  => 'test name#0 data',
                region                => 'test region#0 data',
                replica_configuration => {
                  failover_target               => true,
                  mysql_replica_configuration   => {
                    ca_certificate            => 'test ca_certificate#0 data',
                    client_certificate        => 'test client_certificate#0 data',
                    client_key                => 'test client_key#0 data',
                    connect_retry_interval    => 586223489,
                    dump_file_path            => 'test dump_file_path#0 data',
                    master_heartbeat_period   => 2641537687,
                    password                  => 'test password#0 data',
                    ssl_cipher                => 'test ssl_cipher#0 data',
                    username                  => 'test username#0 data',
                    verify_server_certificate => true,
                  },
                  replica_names                 => ['ee', 'ff', 'gg', 'hh'],
                  service_account_email_address => 'test service_account_email_address#0 data',
                },
                settings              => {
                  ip_configuration => {
                    authorized_networks => [
                      {
                        expiration_time => '2018-07-08T02:10:16+00:00',
                        name            => 'test name#0 data',
                        value           => 'test value#0 data',
                      },
                      {
                        expiration_time => '2067-01-12T04:20:32+00:00',
                        name            => 'test name#1 data',
                        value           => 'test value#1 data',
                      },
                      {
                        expiration_time => '2115-07-20T06:30:48+00:00',
                        name            => 'test name#2 data',
                        value           => 'test value#2 data',
                      },
                    ],
                    ipv4_enabled        => true,
                    require_ssl         => true,
                  },
                  tier             => 'test tier#0 data',
                },
                project               => 'test project#0 data',
                credential            => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]').provider.ensure
          end

          it { is_expected.to eq :present }
        end

        # Ensure present: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  context 'ensure == absent' do
    context 'resource missing' do
      # Ensure absent: resource missing, ignore, no name
      context 'title == name' do
        # Ensure absent: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            expect_network_get_failed 1, name: 'title0'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure     => absent,
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure absent: resource missing, ignore, has name
      context 'title != name' do
        # Ensure absent: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            expect_network_get_failed 1
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure     => absent,
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end

    context 'resource exists' do
      # Ensure absent: resource exists, ignore, no name
      context 'title == name' do
        # Ensure absent: resource exists, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            expect_network_get_success 1, name: 'title0'
            expect_network_delete 1, 'title0'
            expect_network_get_async 1, name: 'title0'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure     => absent,
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource exists, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure absent: resource exists, ignore, has name
      context 'title != name' do
        # Ensure absent: resource exists, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            expect_network_get_success 1
            expect_network_delete 1
            expect_network_get_async 1
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gsql_instance { 'title0':
                ensure     => absent,
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gsql_instance[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource exists, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  context '#flush' do
    subject do
      Puppet::Type.type(:gsql_instance).new(
        ensure: :present,
        name: 'my-name'
      ).provider
    end
    context 'no-op' do
      it { subject.flush }
    end
    context 'modified object' do
      before do
        subject.dirty :some_property, 'current', 'newvalue'
      end
      context 'no-op if created' do
        before { subject.instance_variable_set(:@created, true) }
        it { expect { subject.flush }.not_to raise_error }
      end
      context 'no-op if deleted' do
        before { subject.instance_variable_set(:@deleted, true) }
        it { expect { subject.flush }.not_to raise_error }
      end
    end
  end

  context '#exports' do
    context 'exports all properties' do
      let(:resource1) { create_type 1 }
      before do
        expect_network_get_success 1
        described_class.prefetch(title0: resource1)
      end

      subject { resource1.exports }

      let(:expected_results) do
        {
          name: 'test name#0 data'
        }
      end
      it { is_expected.to eq(expected_results) }
    end
  end

  private

  def expect_network_get_success(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result("success#{id}~#{id_data}.yaml").to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{self_link(uri_data(id).merge(data))}"
    expect(Google::Sql::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def http_success(body)
    response = Net::HTTPOK.new(1.0, 200, 'OK')
    response.body = body
    response.instance_variable_set(:@read, true)
    response
  end

  def expect_network_get_async(id, data = {})
    body = { kind: 'sql#instance' }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Sql::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET <async> #{args}"
      request
    end
  end

  def expect_network_get_failed(id, data = {})
    request = double('request')
    allow(request).to receive(:send).and_return(http_failed_object_missing)

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Sql::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET [failed] #{args}"
      request
    end
  end

  def http_failed_object_missing
    Net::HTTPNotFound.new(1.0, 404, 'Not Found')
  end

  def expect_network_create(id, expected_body, data = {})
    merged_uri = uri_data(id).merge(data)
    body = { kind: 'sql#operation',
             status: 'DONE', targetLink: self_link(merged_uri) }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! POST #{collection(merged_uri)}"
    expect(Google::Sql::Network::Post).to receive(:new)
      .with(collection(merged_uri), instance_of(Google::FakeAuthorization),
            'application/json', expected_body.to_json) do |args|
      debug_network ">> POST #{args} = body(#{body})"
      request
    end
  end

  def expect_network_delete(id, name = nil, data = {})
    delete_data = uri_data(id).merge(data)
    delete_data[:name] = name unless name.nil?
    body = { kind: 'sql#operation',
             status: 'DONE',
             targetLink: self_link(delete_data) }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! DELETE #{self_link(delete_data)}"
    expect(Google::Sql::Network::Delete).to receive(:new)
      .with(self_link(delete_data),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> DELETE #{args}"
      request
    end
  end

  def load_network_result(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gsql_instance', file)
    debug("Loading result file: #{results}")
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  def debug(message)
    puts(message) if ENV['RSPEC_DEBUG']
  end

  def debug_network(message)
    puts("Network #{message}") \
      if ENV['RSPEC_DEBUG'] || ENV['RSPEC_HTTP_VERBOSE']
  end

  def create_type(id)
    Puppet::Type.type(:gsql_instance).new(
      ensure: :present,
      title: "title#{id - 1}",
      credential: "cred#{id - 1}",
      project: GoogleTests::Constants::I_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::I_PROJECT_DATA.size],
      name: GoogleTests::Constants::I_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::I_NAME_DATA.size]
    )
  end

  def expand_variables(template, data, extra_data = {})
    Puppet::Type.type(:gsql_instance).provider(:google)
                .expand_variables(template, data, extra_data)
  end

  def collection(data)
    URI.join(
      'https://www.googleapis.com/sql/v1beta4/',
      expand_variables(
        'projects/{{project}}/instances',
        data
      )
    )
  end

  def self_link(data)
    URI.join(
      'https://www.googleapis.com/sql/v1beta4/',
      expand_variables(
        'projects/{{project}}/instances/{{name}}',
        data
      )
    )
  end

  # Creates variable test data to comply with self_link URI parameters
  def uri_data(id)
    {
      project: GoogleTests::Constants::I_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::I_PROJECT_DATA.size],
      name: GoogleTests::Constants::I_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::I_NAME_DATA.size]
    }
  end
end
